#include "header\gba.h"
#include "header\bg.h"
#include "header\timer.h"
#include "header\dma.h"
#include "header\irq.h"
#include "header\sound.h"
#include "header\sprite.h"
#include "header\blend.h"

#include "header\font\BGFont.h"
//#include "header\font\BitMapFont.h"

#include "lib.h"
#include "syscall.h"
#include "resource.h"

#include <stdlib.h>

//Mode0
//BG0 
//BG2 
//BG3 Ֆ

//---------------------------------------------------------------------------
//is
#define STATE_INIT 					1
#define STATE_RESET					2
#define STATE_MAKE					3
#define STATE_CHECK					4
#define STATE_INPUT					5
#define STATE_MOVE					6
#define STATE_COPY					7
#define STATE_DELETE				8
#define STATE_END					9

//Xe[W̃TCY
#define STAGE_CX					(5+2)	//+2͊O̕ǔzup
#define STAGE_CY					(9+1)

//\pBG^C
#define BG_TILE_EMPTY				0
#define BG_TILE_WALL				2
#define BG_TILE_CELL				4
#define BG_TILE_STONE_RED			6
#define BG_TILE_STONE_BLUE			8
#define BG_TILE_STONE_GREEN			10

#define BG_TILE_STONE_TYPE_CNT		3

//Q[̐ݒ
#define STONE_APPEAR_X1				3		//΂̏\ʒu
#define STONE_APPEAR_Y1				0
#define STONE_APPEAR_X2				3
#define STONE_APPEAR_Y2				1
#define STONE_NEXT_X1				7		//̐΂̕\ʒu
#define STONE_NEXT_Y1				1
#define STONE_NEXT_X2				7
#define STONE_NEXT_Y2				2
#define STONE_SEARCH_NOMARK			0		//Ǎp@tOȂ
#define STONE_SEARCH_DECISION		1		//Ǎp@mtO
#define STONE_SEARCH_PREPARATION	2		//Ǎp@tO
#define STONE_FALL_SPEED			500

#define SCORE_X						13
#define SCORE_Y						1

//SRAMZ[ü
#define SRAM_RANDOM_OFFSET			0

//---------------------------------------------------------------------------
//
typedef struct {
	s16 x;
	s16 y;
	u8  bg;
} ST_STONE;

//Ֆ
typedef struct {
	u8       cell[STAGE_CX][STAGE_CY];
	ST_STONE st1;
	ST_STONE st2;
} ST_BOARD;

//Ֆʂ̘Ap
typedef struct {
	u8 flag[STAGE_CX][STAGE_CY];
	u8 preparationCnt;						//mtOJEg
	u8 decisionCnt;							//tOJEg
} ST_SEARCH;

//vC[
typedef struct {
	ST_STONE st1;
	ST_STONE st2;
	u8       key;							//ړp
	u16      score;
} ST_PLAYER;

//---------------------------------------------------------------------------
//lib.c
extern ST_TIMER Timer;

//---------------------------------------------------------------------------
ST_BG     BG0;
ST_BG     BG2;
ST_BG     BG3;
ST_PLAYER Player;
ST_BOARD  Board;
ST_SEARCH Search;

u8  State;
u32 Random;
u32 FallTime;
//---------------------------------------------------------------------------
void StateInit();
void StateReset();
void StateMake();
void StateCheck();
void StateInput();
void StateMove();
void StateCopy();
void StateDelete();
void StateEnd();

void InitWS();
void InitBG();
void InitKey();
void IRQUserHandler();

void InitPlayer();
void InitStage();
void InitSearch();

u8   StoneGetRandomBg();
bool StoneChkAppear();
bool StoneChkMove(u8 x, u8 y);
void StoneChange();

bool StoneDelete();
bool StoneDeleteChk(u8 argX, u8 argY);
void StoneDeleteExec();

void StoneStuff();
void StoneStuffExec(u8 x);
bool StoneStuffChk(u8 x);

void DrawBG(u8 x, u8 y, u8 tile, u8 map, u8 col);
void DrawBGStone(u8 x, u8 y, u8 bg, bool dispFlg);
void DrawBGStonePlayer(bool isDraw);
void DrawBGStoneStage(bool isDraw);

void ProcKeyInput();
void TimerReset();
//---------------------------------------------------------------------------
int main()
{
	State = STATE_INIT;

	for(;;)
	{
		WaitForVsync();

		switch(State)
		{
			case STATE_INIT:   StateInit();   break;
			case STATE_RESET:  StateReset();  break;
			case STATE_MAKE:   StateMake();   break;
			case STATE_CHECK:  StateCheck();  break;
			case STATE_INPUT:  StateInput();  break;
			case STATE_MOVE:   StateMove();   break;
			case STATE_COPY:   StateCopy();   break;
			case STATE_DELETE: StateDelete(); break;
			case STATE_END:    StateEnd();    break;

			default:
				DebugMessage((u8*)"Err: Main State");
				break;
		}
	}

	return 0;
}
//---------------------------------------------------------------------------
void StateInit()
{
	InitWS();
	InitBG();
	InitKey();

	SetMode(MODE_0 | BG0_ENABLE | BG2_ENABLE | BG3_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);
	State = STATE_RESET;
}
//---------------------------------------------------------------------------
void InitWS()
{
	REG_WSCNT = CST_ROM0_1ST_3WAIT | CST_ROM0_2ND_1WAIT;
}
//---------------------------------------------------------------------------
void InitBG()
{
	//BG0 
	//BG2 
	//BG3 Ֆ

	BG0.chr = 1;
	BG0.map = 0;
	BG0.col = 0;

	BG2.chr = 2;	//BG3Ɠ
	BG2.map = 2;
	BG2.col = 1;	//BG3Ɠ

	BG3.chr = 2;
	BG3.map = 1;
	BG3.col = 1;

	REG_BG0CNT = (BG_SIZEA_256_256     | BG_COLOR_16         |
				  BG_CHARBASE(BG0.chr) | BG_MAPBASE(BG0.map) | 0);

	REG_BG2CNT = (BG_SIZEA_256_256     | BG_COLOR_16         |
				  BG_CHARBASE(BG2.chr) | BG_MAPBASE(BG2.map) | 0);

	REG_BG3CNT = (BG_SIZEA_256_256     | BG_COLOR_16         |
				  BG_CHARBASE(BG3.chr) | BG_MAPBASE(BG3.map) | 0);

	BGSetPal16  (BG0.col, (u16*)&BGFont_palette);
	BGSetChrData(BG0.chr, (u16*)&BGFont_data, BGFont_DATA_SIZE);

	BGSetPal16  (BG3.col, (u16*)&game_bg_pal_bin);
	BGSetChrData(BG3.chr, (u16*)&game_bg_img_bin, GAME_BG_IMG_SIZE);
}
//---------------------------------------------------------------------------
void InitKey()
{
	KeyInit();

	FallTime = 0;

	//L[͗p̃^C}ݒ
	REG_INTERUPT = (u32)IRQUserHandler;
	REG_IE       = IRQ_BIT_TIMER0;
	REG_IME      = IRQ_MASTER_ON;

	REG_TM0D     = 65536 - 2621; // (((16*1024*1024) / 64) * 10) / 1000
	REG_TM0CNT   = TM_ENABLE | TM_FREQ_PER_64 | TM_USEIRQ;
}
//---------------------------------------------------------------------------
void IRQUserHandler()
{
	Timer.clockTick += TIMER_INTMS;
	FallTime        += TIMER_INTMS;
	REG_IF = IRQ_BIT_TIMER0;
}
//---------------------------------------------------------------------------
void StateReset()
{
	InitPlayer();
	InitStage();
	InitSearch();

	State = STATE_MAKE;
}
//---------------------------------------------------------------------------
void InitPlayer()
{
	ST_PLAYER* p = &Player;

	p->st1.x  = 0;
	p->st1.y  = 0;
	p->st1.bg = BG_TILE_EMPTY;

	p->st2.x  = 0;
	p->st2.y  = 0;
	p->st2.bg = BG_TILE_EMPTY;

	p->key    = KEY_NONE;		//ړp
	p->score  = 0;
}
//---------------------------------------------------------------------------
void InitStage()
{
	ST_BOARD* p = &Board;
	s16 x, y;

	for(y=0; y<STAGE_CY; y++)
	{
		for(x=0; x<STAGE_CX; x++)
		{
			p->cell[x][y] = BG_TILE_EMPTY;
		}
	}

	for(x=0; x<STAGE_CX; x++)
	{
//		p->cell[x][0]          = BG_TILE_WALL;
		p->cell[x][STAGE_CY-1] = BG_TILE_WALL;
	}
	for(y=0; y<STAGE_CY; y++)
	{
		p->cell[0][y]          = BG_TILE_WALL;
		p->cell[STAGE_CX-1][y] = BG_TILE_WALL;
	}

	//ڂ̕`
	for(y=0; y<STAGE_CY-1; y++)
	{
		for(x=1; x<STAGE_CX-1; x++)
		{
			DrawBG(x*2, y*2, BG_TILE_CELL, BG3.map, BG3.col);
		}
	}

	//̐΂Zbg
	Board.st1.x  = STONE_NEXT_X1;
	Board.st1.y  = STONE_NEXT_Y1;
	Board.st1.bg = StoneGetRandomBg();

	Board.st2.x  = STONE_NEXT_X2;
	Board.st2.y  = STONE_NEXT_Y2;
	Board.st2.bg = StoneGetRandomBg();
}
//---------------------------------------------------------------------------
void StateMake()
{
	//΂Zbg
	Player.st1.x  = STONE_APPEAR_X1;
	Player.st1.y  = STONE_APPEAR_Y1;
	Player.st1.bg = Board.st1.bg;

	Player.st2.x  = STONE_APPEAR_X2;
	Player.st2.y  = STONE_APPEAR_Y2;
	Player.st2.bg = Board.st2.bg;

	//̐΂Zbg
	Board.st1.bg  = StoneGetRandomBg();
	Board.st2.bg  = StoneGetRandomBg();

	DrawBGStonePlayer(TRUE);
	DrawBGStoneStage(TRUE);

	TimerReset();
	Player.key = KEY_NONE;
	State = STATE_CHECK;
}
//---------------------------------------------------------------------------
u8 StoneGetRandomBg()
{
	u8 ret = BG_TILE_EMPTY;
	u8 rnd = rand() % BG_TILE_STONE_TYPE_CNT;

	switch(rnd)
	{
		case 0: ret = BG_TILE_STONE_RED;   break;
		case 1: ret = BG_TILE_STONE_BLUE;  break;
		case 2: ret = BG_TILE_STONE_GREEN; break;
		default: DebugMessage((u8*)"Err: GetRandomStoneType r"); break;
	}

	return ret;
}
//---------------------------------------------------------------------------
void DrawBGStone(u8 x, u8 y, u8 bg, bool dispFlg)
{
	u8 bgTile;

	if(dispFlg == TRUE) bgTile = bg;
	else                bgTile = BG_TILE_EMPTY;

	DrawBG(x*2, y*2, bgTile, BG2.map, BG2.col);
}
//---------------------------------------------------------------------------
void DrawBG(u8 x, u8 y, u8 tile, u8 map, u8 col)
{
	BGDrawChar(map, x+0, y+0, col, tile+0 );
	BGDrawChar(map, x+1, y+0, col, tile+1 );
	BGDrawChar(map, x+0, y+1, col, tile+32);
	BGDrawChar(map, x+1, y+1, col, tile+33);
}
//---------------------------------------------------------------------------
void StateInput()
{
	//`FbN(FallTime̓^C}荞݂ŃJEg𑝂₵܂)
	if(FallTime >= STONE_FALL_SPEED)
	{
		Player.key = KEY_DOWN;
		State      = STATE_CHECK;
		return;
	}

	ProcKeyInput();
}
//---------------------------------------------------------------------------
void ProcKeyInput()
{
	if( KeyWaitTimer() == TRUE )
	{
		return;
	}
	if( KeyRepeat() == TRUE )		//keyGet֐ĂԑOɕKsȂ
	{
		return;
	}

	u8 key = KeyGet();
	if(key == KEY_NONE)
	{
		return;
	}

	if(key & KEY_DOWN ) Player.key = KEY_DOWN;
	if(key & KEY_LEFT ) Player.key = KEY_LEFT;
	if(key & KEY_RIGHT) Player.key = KEY_RIGHT;
	if(key & KEY_A    ) Player.key = KEY_A;

	State = STATE_CHECK;
}
//---------------------------------------------------------------------------
void StateCheck()
{
	ST_STONE* ps1 = &Player.st1;
	ST_STONE* ps2 = &Player.st2;

	switch(Player.key)
	{
	//
	case KEY_NONE:
		//lݏԂ`FbN
		if( StoneChkAppear() == TRUE )
		{
			State = STATE_END;
			return;
		}
		State = STATE_INPUT;
		return;


	case KEY_DOWN:
		//ړ\`FbN
		if(   StoneChkMove(ps1->x, ps1->y+1) 
		   && StoneChkMove(ps2->x, ps2->y+1) )
		{
			State = STATE_MOVE;
			return;
		}
		State = STATE_COPY;
		return;


	case KEY_RIGHT:
		//ړ\`FbN
		if(   StoneChkMove(ps1->x+1, ps1->y) 
		   && StoneChkMove(ps2->x+1, ps2->y) )
		{
			State = STATE_MOVE;
			return;
		}
		State = STATE_INPUT;
		return;


	case KEY_LEFT:
		//ړ\`FbN
		if(   StoneChkMove(ps1->x-1, ps1->y) 
		   && StoneChkMove(ps2->x-1, ps2->y) )
		{
			State = STATE_MOVE;
			return;
		}
		State = STATE_INPUT;
		return;


	case KEY_A:
		State = STATE_MOVE;
		return;


	default:
		DebugMessage((u8*)"Err: GameStateCheck Player.key");
		return;
	}
}
//---------------------------------------------------------------------------
//΂̈ړ`FbN(TRUE: ړł FALSE: ړłȂ)
bool StoneChkMove(u8 x, u8 y)
{
	return Board.cell[x][y] == BG_TILE_EMPTY ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
bool StoneChkAppear()
{
	bool ret = FALSE;

	ret |= Board.cell[STONE_APPEAR_X1][STONE_APPEAR_Y1] ? TRUE : FALSE;
	ret |= Board.cell[STONE_APPEAR_X2][STONE_APPEAR_Y2] ? TRUE : FALSE;

	return ret;
}
//---------------------------------------------------------------------------
void TimerReset()
{
	REG_TM0D        = 65536 - 2621; // (((16*1024*1024) / 64) * 10) / 1000
	Timer.clockTick = 0;
	FallTime        = 0;
}
//---------------------------------------------------------------------------
void StateMove()
{
	DrawBGStonePlayer(FALSE);

	ST_STONE* ps1 = &Player.st1;
	ST_STONE* ps2 = &Player.st2;

	if(Player.key & KEY_DOWN ){ ps1->y++; ps2->y++; TimerReset(); }
	if(Player.key & KEY_LEFT ){ ps1->x--; ps2->x--; }
	if(Player.key & KEY_RIGHT){ ps1->x++; ps2->x++; }
	if(Player.key & KEY_A    ){ StoneChange();      }

	DrawBGStonePlayer(TRUE);

	Player.key = KEY_NONE;
	State      = STATE_INPUT;
}
//---------------------------------------------------------------------------
void StoneChange()
{
	u8 tmp        = Player.st1.bg;
	Player.st1.bg = Player.st2.bg;
	Player.st2.bg = tmp;
}
//---------------------------------------------------------------------------
void StateCopy()
{
	ST_STONE* ps1 = &Player.st1;
	ST_STONE* ps2 = &Player.st2;

	Board.cell[ps1->x][ps1->y] = ps1->bg;
	Board.cell[ps2->x][ps2->y] = ps2->bg;

	State = STATE_DELETE;
}
//---------------------------------------------------------------------------
void StateDelete()
{
StatDel:
	//΂̂SA`FbN܂
	if( StoneDelete() == TRUE )
	{
		//Aď͋l߂`
		StoneStuff();
		goto StatDel;
	}

	State = STATE_MAKE;
}
//---------------------------------------------------------------------------
bool StoneDelete()
{
	bool ret = FALSE;
	s16 x, y;

	for(y=0; y<STAGE_CY-1; y++)
	{
		for(x=1; x<STAGE_CX-1; x++)
		{
			if(Board.cell[x][y] != BG_TILE_EMPTY)
			{
				ret |= StoneDeleteChk(x, y);
			}
		}
	}

	return ret;
}
//---------------------------------------------------------------------------
//̍WAꍇFTRUE  ȂꍇFFALSE
bool StoneDeleteChk(u8 argX, u8 argY)
{
	InitSearch();

	ST_SEARCH* p = &Search;

	p->flag[argX][argY] = STONE_SEARCH_PREPARATION;
	p->preparationCnt   = 1;
	p->decisionCnt      = 0;

	u8 bg = Board.cell[argX][argY];
	s16 x, y;
	do
	{
		for(y=1; y<STAGE_CY-1; y++)
		{
			for(x=1; x<STAGE_CX-1; x++)
			{
				if(p->flag[x][y] != STONE_SEARCH_PREPARATION)
				{
					continue;
				}

				p->flag[x][y] = STONE_SEARCH_DECISION;
				p->decisionCnt++;
				p->preparationCnt--;

				//
				if(bg == Board.cell[x  ][y-1] && p->flag[x  ][y-1] == STONE_SEARCH_NOMARK)
				{
					p->flag[x  ][y-1] = STONE_SEARCH_PREPARATION;
					p->preparationCnt++;
				}

				//
				if(bg == Board.cell[x  ][y+1] && p->flag[x  ][y+1] == STONE_SEARCH_NOMARK)
				{
					p->flag[x  ][y+1] = STONE_SEARCH_PREPARATION;
					p->preparationCnt++;
				}

				//
				if(bg == Board.cell[x-1][y  ] && p->flag[x-1][y  ] == STONE_SEARCH_NOMARK)
				{
					p->flag[x-1][y  ] = STONE_SEARCH_PREPARATION;
					p->preparationCnt++;
				}

				//E
				if(bg == Board.cell[x+1][y  ] && p->flag[x+1][y  ] == STONE_SEARCH_NOMARK)
				{
					p->flag[x+1][y  ] = STONE_SEARCH_PREPARATION;
					p->preparationCnt++;
				}
			}// for x
		}// for y

	} while(p->preparationCnt != 0);

	//SAȏォ`FbN
	if(p->decisionCnt >= 4)
	{
		StoneDeleteExec();
		return TRUE;
	}

	return FALSE;
}
//---------------------------------------------------------------------------
void StoneDeleteExec()
{
	ST_SEARCH* p = &Search;
	s16 x, y;

	for(y=0; y<STAGE_CY-1; y++)
	{
		for(x=1; x<STAGE_CX-1; x++)
		{
			if(p->flag[x][y] == STONE_SEARCH_DECISION)
			{
				Board.cell[x][y] = BG_TILE_EMPTY;

				DrawBGStone(x, y, BG_TILE_EMPTY, TRUE);
			}
		}
	}
}
//---------------------------------------------------------------------------
void StoneStuff()
{
	s16 x;

	x = 1;
	while(x < STAGE_CX-1)
	{
		if( StoneStuffChk(x) == TRUE )
		{
			StoneStuffExec(x);
			continue;
		}

		x++;
	}
}
//---------------------------------------------------------------------------
bool StoneStuffChk(u8 x)
{
	bool emptyFlg = FALSE;
	s16  y;

	for(y=STAGE_CY-1; y>0; y--)
	{
		if(Board.cell[x][y] == BG_TILE_EMPTY)
		{
			emptyFlg = TRUE;
			continue;
		}

		if(emptyFlg == TRUE)
		{
			return TRUE;
		}
	}

	return FALSE;
}
//---------------------------------------------------------------------------
void StoneStuffExec(u8 x)
{
	s16 y;

	for(y=STAGE_CY-1; y>0; y--)
	{
		if(Board.cell[x][y] == BG_TILE_EMPTY)
		{
			Board.cell[x][y  ] = Board.cell[x][y-1];
			Board.cell[x][y-1] = BG_TILE_EMPTY;

			DrawBGStone(x, y  , Board.cell[x][y  ], TRUE);
			DrawBGStone(x, y-1, Board.cell[x][y-1], TRUE);
		}
	}
}
//---------------------------------------------------------------------------
void StateEnd()
{
	
}
//---------------------------------------------------------------------------
void InitSearch()
{
	s16 x, y;

	for(y=0; y<STAGE_CY; y++)
	{
		for(x=0; x<STAGE_CX; x++)
		{
			Search.flag[x][y] = STONE_SEARCH_NOMARK;
		}
	}
}
//---------------------------------------------------------------------------
void DrawBGStonePlayer(bool isDraw)
{
	ST_PLAYER* p = &Player;

	DrawBGStone(p->st1.x, p->st1.y, p->st1.bg, isDraw);
	DrawBGStone(p->st2.x, p->st2.y, p->st2.bg, isDraw);
}
//---------------------------------------------------------------------------
void DrawBGStoneStage(bool isDraw)
{
	ST_BOARD* p = &Board;

	DrawBGStone(p->st1.x, p->st1.y, p->st1.bg, isDraw);
	DrawBGStone(p->st2.x, p->st2.y, p->st2.bg, isDraw);
}
